sub rangeip {
	my $data = shift;
	my $nb_core_discovery = shift;

	#****** Definition of variables ******#
	my %ipstart;
	my %ipend;
	my %range_entity;
	my $key;
	my @numbers_ipstart;
	my @numbers_ipend;
	my %iplist;
	my $nbip = 0;
	my $core_counter = 0;

	#****** Get IP from Serveur ******#
	foreach $key (keys (%{$data->{discovery}->{rangeip}})) {
		if ($key =~ /^-?\d/) {
			$ipstart{$key} = $data->{discovery}->{rangeip}->{$key}->{ipstart};
			$ipend{$key} = $data->{discovery}->{rangeip}->{$key}->{ipend};
			$range_entity{$key} = $data->{discovery}->{rangeip}->{$key}->{entity};
		} else {
			$ipstart{$data->{discovery}->{rangeip}->{id}} = $data->{discovery}->{rangeip}->{ipstart};
			$ipend{$data->{discovery}->{rangeip}->{id}} = $data->{discovery}->{rangeip}->{ipend};
			$range_entity{$data->{discovery}->{rangeip}->{id}} = $data->{discovery}->{rangeip}->{entity};
		}
	}

	#****** Foreach range IP, extract all IP addresses ******#
	while (my ($key_ip,$value_ip)= each %ipstart) {
		@numbers_ipstart = split(/\./,$value_ip);
		@numbers_ipend = split(/\./,$ipend{$key_ip});
		my $i = 0;

		my $ip1 = $numbers_ipstart[0];
		my $ip2 = $numbers_ipstart[1];
		my $ip3 = $numbers_ipstart[2];
		my $ip4 = $numbers_ipstart[3];
		while($i < 1) {
			if ($core_counter == $nb_core_discovery) {
				$core_counter = 0;
			}
			$iplist{$core_counter}{$ip1.".".$ip2.".".$ip3.".".$ip4} = $range_entity{$key_ip};
			$core_counter++;
			$nbip++;
			
			# Increment for next IP
			if (($ip1 == $numbers_ipend[0]) && ($ip2 == $numbers_ipend[1])	&& ($ip3 == $numbers_ipend[2])) {
				if ($ip4 == $numbers_ipend[3]) {
					$i = 1;
				}
			} elsif (($ip1 == $numbers_ipend[0]) && ($ip2 == $numbers_ipend[1]))	{
				if ($ip4 == "254") {
					$ip4 = -1;
					$ip3++;
				}
			} elsif (($ip1 == $numbers_ipend[0])) {
				if (($ip4 == "254") && ($ip3 == "254")) {
					$ip4 = -1;
					$ip3 = 0;
					$ip2++;
				} elsif ($ip4 == "254") {
					$ip4 = -1;
					$ip3++;
				}
			} else {
				if (($ip4 == "254") && ($ip3 == "254") && ($ip2 == "254")) {
					$ip4 = -1;
					$ip3 = 0;
					$ip2 = 0;
					$ip1++;
				} elsif (($ip4 == "254") && ($ip3 == "254")) {
					$ip4 = -1;
					$ip3 = 0;
					$ip2++;
				} elsif ($ip4 == "254") {
					$ip4 = -1;
					$ip3++;
				}

			}
			$ip4++;
		}
	}
	
	return($nbip,\%iplist);
}


sub discovery_auth {
	$data = shift;
	
	my %authSNMP_discovery;

	if (ref($data->{discovery}->{authentification}->{1}) eq "HASH") {
		foreach my $key (keys (%{$data->{discovery}->{authentification}})) {
			$authSNMP_discovery{$key}{'ID'} = $key;
			$authSNMP_discovery{$key}{'version'} = $data->{discovery}->{authentification}->{$key}->{version};
			$authSNMP_discovery{$key}{'community'} = $data->{discovery}->{authentification}->{$key}->{community};
			$authSNMP_discovery{$key}{'username'} = $data->{discovery}->{authentification}->{$key}->{username};
			$authSNMP_discovery{$key}{'authkey'}  = $data->{discovery}->{authentification}->{$key}->{authkey};
			$authSNMP_discovery{$key}{'authpassword'} = $data->{discovery}->{authentification}->{$key}->{authpassword};
			$authSNMP_discovery{$key}{'authprotocol'} = $data->{discovery}->{authentification}->{$key}->{auth_protocol};
			$authSNMP_discovery{$key}{'privkey'} = $data->{discovery}->{authentification}->{$key}->{privkey};
			$authSNMP_discovery{$key}{'privpassword'} = $data->{discovery}->{authentification}->{$key}->{priv_passphrase};
			$authSNMP_discovery{$key}{'privprotocol'} = $data->{discovery}->{authentification}->{$key}->{priv_protocol};
		}
	} else {
		$key = 1;
		$authSNMP_discovery{$key}{'ID'} = $key;
		$authSNMP_discovery{$key}{'version'} = $data->{discovery}->{authentification}->{version};
		$authSNMP_discovery{$key}{'community'} = $data->{discovery}->{authentification}->{community};
		$authSNMP_discovery{$key}{'username'} = $data->{discovery}->{authentification}->{username};
		$authSNMP_discovery{$key}{'authkey'}  = $data->{discovery}->{authentification}->{authkey};
		$authSNMP_discovery{$key}{'authpassword'} = $data->{discovery}->{authentification}->{authpassword};
		$authSNMP_discovery{$key}{'authprotocol'} = $data->{discovery}->{authentification}->{auth_protocol};
		$authSNMP_discovery{$key}{'privkey'} = $data->{discovery}->{authentification}->{privkey};
		$authSNMP_discovery{$key}{'privpassword'} = $data->{discovery}->{authentification}->{priv_passphrase};
		$authSNMP_discovery{$key}{'privprotocol'} = $data->{discovery}->{authentification}->{priv_protocol};
	}

	return \%authSNMP_discovery;
}



sub discovery_threaded {
	my $nb_threads_discovery = shift;
	my $nb_core_discovery = shift;
	my $log = shift;
	my $Bin = shift;
	my $config = shift;
	my $PID = shift;
	my $fragment = shift;
	my $iplist = shift;
	my $authSNMP_discovery1 = shift;
   my $nbip = shift;
   my $argnodisplay = shift;
   my $argnoprogressbar = shift;


	my $xml = '';
	my $i = 0;
	my $num_files = 1;
	my $counter=0;

	debug($log,"==== Discovery ====","",$PID,$Bin);

	#===================================
	# Threads et variables partagées
	#===================================
	my $TuerThread : shared = 0;       # Permet de tuer le thread proprement
	my $NomFonction : shared;         # Contient le nom de la fonction à appeler
	my %ThreadTravail : shared;       # Contient la valeur permettant au thread de lancer une procédure
	my %ArgumentsThread :shared;     # Contient les arguements à passer à une éventuelle procédure
	my %ResultatFonction : shared;    # Contient le résultat des fonctions lancées dans le thread
   my %authSNMP_discovery : shared;
	my $Thread = ();

   $authSNMP_discovery = $authSNMP_discovery1;
	$ArgumentsThread{'ip'} = &share([]);
	$ArgumentsThread{'entity'} = &share([]);
	$ArgumentsThread{'authSNMP_discovery'} = &share([]);
	$ArgumentsThread{'log'} = &share([]);
	$ArgumentsThread{'Bin'} = &share([]);
	$ArgumentsThread{'PID'} = &share([]);
   $ArgumentsThread{'xml'} = &share([]);

   #============================================
	# Load progress bar
	#============================================
#   if (($argnoprogressbar == 0) && ($argnodisplay == 0)) {
#      my $state : shared = 0;
#
#      my %options = (
#         create    => 'yes',
#         exclusive => 0,
#         mode      => 0644,
#         destroy   => 'yes',
#      );
#      my $ipcounter;
#      $ipcshare = tie $ipcounter, 'IPC::Shareable', 'data', { %options } or
#        die "server: tie failed\n";
#      $ipcounter = 0;
#
#      # Create Thread
#      $Thread_progress_bar = threads->create( sub {
#                                              my @spin = ('|','/','-','\\');
#                                              my $i = 0;
#
#                                              $i = ($i+1) % scalar @spin;
#                                              while(1)
#                                              {
#                                                 if ($ipcounter eq "END") {
#                                                    print chr 8;
#                                                    print chr 8;
#                                                     return;
#                                                   }
#                                                   print "[".$ipcounter." / ".$nbip."] ".$spin[$i];
#                                                   sleep 1;
#
#                                                  foreach(my $k=0 ; $k < (length($ipcounter) + length($nbip) + 7) ; $k++) {
#                                                      print chr 8;
#                                                  }
#                                                  $i = ($i+1) % scalar @spin;
#                                              }
#
#                                             return;
#                                          });
#   }
   #============================================
	# Begin ForkManager (multiple core / process)
	#============================================
   $max_procs = $nb_core_discovery*$nb_threads_discovery;
	$pm=new Parallel::ForkManager($max_procs);

	for(my $p = 0; $p < $nb_core_discovery; $p++) {
		$pid = $pm->start and next;
      write_pid();
      # Création des threads
      $ThreadTravail{$p} = &share([]);
      $TuerThread{$p} = &share([]);
      for(my $j = 0 ; $j < $nb_threads_discovery ; $j++) {
         $ThreadTravail{$p}[$j] = 0;               # 0 : thread ne fait rien, 1 : il bosse
         $TuerThread{$p}[$j]    = 0;					# 0 : thread en vie, 1 : thread se termine
      }

      #===================================
      # Create all Threads
      #===================================
      for(my $j = 0; $j < $nb_threads_discovery; $j++) {
         @args = ($p, $j);
         #$Thread[$p][$j] = threads->create( \&discovery_thread, \@args);
         $Thread[$p][$j] = threads->create( sub {
                                                $p = $args[0];
                                                $t = $args[1];
#                                                if (($argnoprogressbar == 0) && ($argnodisplay == 0)) {
#                                                   my $count;
#                                                   tie $count, 'IPC::Shareable', 'data', { 'destroy' => 'Yes!' };
#                                                }

                                                while (1) {
                                                   #print $p." - ".$t."\n";
                                                   if ( $ThreadTravail{$p}[$t] == 1 ) {
                                                      # Lance la procédure et récupère le résultat
                                                      $tmp = discovery_ip_threaded(
                                                         $ArgumentsThread{'ip'}[$p][$t],
                                                         $ArgumentsThread{'entity'}[$p][$t],
                                                         $authSNMP_discovery,
                                                         $ArgumentsThread{'log'}[$p][$t],
                                                         $ArgumentsThread{'Bin'}[$p][$t],
                                                         $ArgumentsThread{'PID'}[$p][$t])."\n";
                                                      if ($tmp ne "\n") {
                                                         $ArgumentsThread{'xml'}[$p][$t] .= $tmp;
                                                      }

#                                                      if (($argnoprogressbar == 0) && ($argnodisplay == 0)) {
#                                                         $ipcshare->shlock;
#                                                         $count++;
#                                                         $ipcshare->shunlock;
#                                                      }

                                                      # demande au thread de dormir
                                                      $ThreadTravail{$p}[$t] = 0;
                                                   }

                                                   # Terminer le thread
                                                   last if ( $TuerThread{$p}[$t] == 1 );
                                                   sleep 1;
                                                }
                                                return;
                                             }, \@args);

      }

      $j = 0;
      $i = 0;
      $ArgumentsThread{'ip'}[$p] = &share([]);
      $ArgumentsThread{'entity'}[$p] = &share([]);
      $ArgumentsThread{'Bin'}[$p] = &share([]);
      $ArgumentsThread{'log'}[$p] = &share([]);
      $ArgumentsThread{'PID'}[$p] = &share([]);
      $ArgumentsThread{'xml'}[$p] = &share([]);

      BOUCLE001: while (my ($ip,$entity) = each %{$$iplist{$p}}) {
         if ($i < $nb_threads_discovery) {
            delete ${$$iplist{$p}}{$ip};
            $NomFonction = "discovery_ip_threaded";
            $ArgumentsThread{'ip'}[$p][$i] = $ip;
            $ArgumentsThread{'entity'}[$p][$i] = $entity;
            $ArgumentsThread{'Bin'}[$p][$i] = $Bin;
            $ArgumentsThread{'log'}[$p][$i] = $log;
            $ArgumentsThread{'PID'}[$p][$i] = $PID;
            $ArgumentsThread{'xml'}[$p][$i] = "";
            $ThreadTravail{$p}[$i] = 1; # On lui demande de bosser
            $i++;
         } else {
            last BOUCLE001;
         }
      }

      while (keys %{$$iplist{$p}} != 0) {
         for(my $i = 0 ; $i < $nb_threads_discovery ; $i++) {
            if ($ThreadTravail{$p}[$i] == 0) {
               while (my ($ip,$entity) = each %{$$iplist{$p}}) {
                  delete ${$$iplist{$p}}{$ip};
                  $ArgumentsThread{'ip'}[$p][$i] = $ip;
                  $ArgumentsThread{'entity'}[$p][$i] = $entity;
                  $ThreadTravail{$p}[$i] = 1; # On lui demande de bosser
                  last;
               }
            }
         }
      }

      for(my $j = 0; $j < $nb_threads_discovery; $j++) {
         while ($ThreadTravail{$p}[$j] == 1) {
            sleep 0.2;
         }
         if (exists($ArgumentsThread{'xml'}[$p][$j])) {
            $xml .= $ArgumentsThread{'xml'}[$p][$j];
         }
         $TuerThread{$p}[$j] = 1;
         #$Thread[$p][$j]->detach();
         $Thread[$p][$j]->join();
      }
      send_snmp_http_threaded($xml, $p, "tmpdiscovery",$config,$PID,0);
#      if (($argnoprogressbar == 0) && ($argnodisplay == 0)) {
#         $Thread_progress_bar->detach();
#      }
      $pm->finish;
   }

   $pm->wait_all_children;

#   if (($argnoprogressbar == 0) && ($argnodisplay == 0)) {
#      sleep 2;
#      $ipcounter = "END";
#      $Thread_progress_bar->detach();
#      print "\n";
#   }
   return $xml;
}



sub discovery_ip_threaded {
#	my $authSNMP_discovery = $args[0][2];
   my $ip = shift;
   my $entity = shift;
   my $authSNMP_discovery = shift;
   my $log = shift;
   my $Bin = shift;
   my $PID = shift;

   #print "ID : ".threads->tid()."\n";
   #print "IP : ".$ip."\n";
   #threads->yield;
   foreach my $key (sort hashValueDescendingNum (keys(%$authSNMP_discovery))) {
      my ($session, $error) = start_session($ip,$$authSNMP_discovery{$key}{'version'},$$authSNMP_discovery{$key}{'community'},$$authSNMP_discovery{$key}{'username'},$$authSNMP_discovery{$key}{'authkey'},$$authSNMP_discovery{$key}{'authpasswd'},$$authSNMP_discovery{$key}{'authprotocol'},$$authSNMP_discovery{$key}{'privkey'},$$authSNMP_discovery{$key}{'privpasswd'},$$authSNMP_discovery{$key}{'privprotocol'},'1');
      if (!defined($session)) {
         print("SNMP ERROR: %s.\n", $error);
      } else {
         $description = snmpget('.1.3.6.1.2.1.1.1.0',1);
         if ($description =~ m/No response from remote host/) {
            debug($log,"[".$ip."][NO][".$$authSNMP_discovery{$key}{'version'}."][".$$authSNMP_discovery{$key}{'community'}."] ".$session->error, "",$PID,$Bin);
         } elsif ($description =~ m/No buffer space available/) {
            debug($log,"[".$ip."][NO][".$$authSNMP_discovery{$key}{'version'}."][".$$authSNMP_discovery{$key}{'community'}."] ".$session->error, "",$PID,$Bin);
         } elsif ($description ne "null") {
            #print "TROUVE\n";
            debug($log,"[".$ip."][YES][".$$authSNMP_discovery{$key}{'version'}."][".$$authSNMP_discovery{$key}{'community'}."]", "",$PID,$Bin);
            
            # ***** manufacturer specifications
            # If HP printer detected, get best sysDescr
            $description = hp_discovery($description);

            # If Wyse thin clients
            $description = wyse_discovery($description);
            #$description = cisco_discovery($description);

            # If Samsung printer detected, get best sysDescr
            $description = samsung_discovery($description);



            my $name = snmpget('.1.3.6.1.2.1.1.5.0',1);
            if ($name eq "null") {
               $name = "";
            }
            # Serial Number
            my ($serial, $type, $model) = verifySerial($description);
            if ($serial eq "Received noSuchName(2) error-status at error-index 1") {
               $serial = '';
            }
            if ($serial eq "noSuchInstance") {
               $serial = '';
            }
            if ($serial eq "noSuchObject") {
               $serial = '';
            }
            $session->close;
            my $tmp_xml = constructxmlDiscovery($description, $name, $serial, $ip, $type,$entity,$model,$$authSNMP_discovery{$key}{'ID'});
            #print $tmp_xml."\n";
            return $tmp_xml;
         } else {
            debug($log,"[".$ip."][NO][".$$authSNMP_discovery{$key}{'version'}."][".$$authSNMP_discovery{$key}{'community'}."] ".$session->error, "",$PID,$Bin);
         }
         $session->close;
      }
   }
   return '';
}



sub verifySerial {
#	$serialreturn = '';
#	$typereturn = '';
#	while (($desc,$oid)= each %SerialNumberDef) {
   if ($_[0] eq "") {
      return ("", 0, "");
   }
	foreach $desc (reverse sort keys %SerialNumberDef) {
		if ($_[0] =~ /$desc/){
         if ($SerialNumberDef{$desc} eq "") {
				$serial = "";
			} else {
				$serial = snmpget($SerialNumberDef{$desc},1);
			}
         if ($serial ne "null") {
            $serialreturn = $serial;
         } else {
            $serialreturn = "";
         }
			$typereturn = $TypeDef{$desc};
			$modelreturn = $ModelDef{$desc};
			if($typereturn eq "") {
				$typereturn = 0;
			}
			return ($serialreturn, $typereturn, $modelreturn);
		}
	}
	return ("", 0, "");
}


1;