sub snmpget {
   $oid = $_[0];
   my $up = $_[1];
   $result = $session->get_request(
      -varbindlist => [$oid]
   );
   if (!defined($result)) {
      my $err = $session->error;
      #debug($log,"[".$_[1]."] Error : ".$err,"",$PID);
      if ((defined $up) && ($up == 1)) {
         $return = "No response from remote host";
      } else {
         $return = "null";
      }
   } else {
      if ($result->{$oid} =~ m/noSuchInstance/) {
         $return = "null";
      } else {
         if ($oid =~ m/No response from remote host/) {
            $return = "null";
         } else {
            if ($oid =~ /.1.3.6.1.2.1.17.4.3.1.1/) {
               $result->{$oid} = getbadmacaddress($oid,$result->{$oid});
            }
            if ($oid =~ /.1.3.6.1.2.1.17.1.1.0/) {
               $result->{$oid} = getbadmacaddress($oid,$result->{$oid});
            }
            if ($oid =~ /.1.3.6.1.2.1.2.2.1.6/) {
               $result->{$oid} = getbadmacaddress($oid,$result->{$oid});
            }
            if ($oid =~ /.1.3.6.1.2.1.4.22.1.2/) {
               $result->{$oid} = getbadmacaddress($oid,$result->{$oid});
            }
            if ($oid =~ /.1.3.6.1.4.1.9.9.23.1.2.1.1.4/) {
               $result->{$oid} = getbadmacaddress($oid,$result->{$oid});
            }
            $result->{$oid} = special_char($result->{$oid});
            $return = $result->{$oid};
         }
      }
   }
   return $return;
}


sub snmpwalk {
   $oid_start = $_[0];
   $oid_prec = $oid_start;
   while($oid_prec =~ m/$oid_start/)
   {
      my $response = $session->get_next_request($oid_prec);
      my $err = $session->error;
      if ($err){
         #debug($log,"[".$_[1]."] Error : ".$err,"",$PID);
         #debug($log,"[".$_[1]."] Oid Error : ".$oid_prec,"",$PID);
         return %ArraySNMP;
      }
      my %pdesc = %{$response};
      #print %pdesc;
      while (($object,$oid) = each (%pdesc))
      {
         if ($object =~ m/$oid_start/)
         {
            if ($object =~ /.1.3.6.1.2.1.17.4.3.1.1/) {
               $oid = getbadmacaddress($object,$oid)
            }
            if ($object =~ /.1.3.6.1.2.1.17.1.1.0/) {
               $oid = getbadmacaddress($object,$oid)
            }
            if ($object =~ /.1.3.6.1.2.1.2.2.1.6/) {
               $oid = getbadmacaddress($object,$oid)
            }
            if ($object =~ /.1.3.6.1.2.1.4.22.1.2/) {
               $oid = getbadmacaddress($object,$oid)
            }
            if ($object =~ /.1.3.6.1.4.1.9.9.23.1.2.1.1.4/) {
               $oid = getbadmacaddress($object,$oid)
            }
            $oid = special_char($oid);
            $ArraySNMP{$object} = $oid;
         }
         $oid_prec = $object;
      }
   }
   return %ArraySNMP;
}



sub snmpgetnext {
   $oid_start = $_[0];
   $oid_prec = $_[1];
   if($oid_prec =~ m/$oid_start/)
   {
      my $response = $session->get_next_request($oid_prec);
      my $err = $session->error;
      if ($err) {
         return ("", "");
      }
      my %pdesc = %{$response};

      while (($object,$oid) = each (%pdesc))
      {
         if ($object =~ m/$oid_start/)
         {
            if ($object =~ /.1.3.6.1.2.1.17.4.3.1.1/) {
               $oid = getbadmacaddress($object,$oid)
            }
            if ($object =~ /.1.3.6.1.2.1.17.1.1.0/) {
               $oid = getbadmacaddress($object,$oid)
            }
            if ($object =~ /.1.3.6.1.2.1.2.2.1.6/) {
               $oid = getbadmacaddress($object,$oid)
            }
            if ($object =~ /.1.3.6.1.2.1.4.22.1.2/) {
               $oid = getbadmacaddress($object,$oid)
            }
            if ($object =~ /.1.3.6.1.4.1.9.9.23.1.2.1.1.4/) {
               $oid = getbadmacaddress($object,$oid)
            }
            $oid = special_char($oid);
            return ($object, $oid);
         }
         $oid_prec = $object;
      }
   }
   return ("", "");
}

sub getbadmacaddress {

   my $OID_ifTable = shift;
   my $oid_value = shift;
   if ($oid_value !~ /0x/) {
      my $OID_ifPhysAddress = $OID_ifTable;

      my %table; # Hash to store the results

      my $result = $session2->get_request(
         -varbindlist => [$OID_ifPhysAddress]
      );

      # Now initiate the SNMP message exchange.

      snmp_dispatcher();

      $table{$OID_ifPhysAddress} = $result->{$OID_ifPhysAddress};
      # Print the results, specifically formatting ifPhysAddress.

      for my $oid (oid_lex_sort(keys %table)) {
         if (!oid_base_match($OID_ifPhysAddress, $oid)) {
            #printf "%s = %s\n", $oid, $table{$oid};
            return $table{$oid};
         } else {
            #printf "%s = %s\n", $oid, unpack 'H*', $table{$oid};
            return "0x".unpack 'H*', $table{$oid};
         }
      }

   }
   return $oid_value;

}


sub start_session {
   if ($_[1] eq "1") {
      if ($_[10] eq "1") {
         ($session, $error) = Net::SNMP->session(
            -version   => 'snmpv1',
            -timeout   => 1,
            -hostname  => $_[0],
            -community => $_[2],
            -port      => 161
         );
      } elsif ($_[10] eq "0") {
         ($session, $error) = Net::SNMP->session(
            -version   => 'snmpv1',
            -timeout   => 1,
            -hostname  => $_[0],
            -community => $_[2],
            -nonblocking => 0,
            -translate   => [-octetstring => 0],
            -port      => 161
         );
      }
   } elsif ($_[1] eq "2c") {
      if ($_[10] eq "1") {
         ($session, $error) = Net::SNMP->session(
            -version   => 'snmpv2c',
            -timeout   => 1,
            -hostname  => $_[0],
            -community => $_[2],
            -port      => 161
         );
      } elsif ($_[10] eq "0") {
         ($session, $error) = Net::SNMP->session(
            -version   => 'snmpv2c',
            -timeout   => 1,
            -hostname  => $_[0],
            -community => $_[2],
            -nonblocking => 0,
            -translate   => [-octetstring => 0],
            -port      => 161
         );
      }
   } elsif ($_[1] eq "3") {
      if ($_[10] eq "1") {
         if($_[9] =~ /hash/i){
            ($session, $error) = Net::SNMP->session(
               -hostname     => $_[0],
               -version      => 'snmpv3',
               -username     => $_[3],
               -authpassword => $_[5],
               -authprotocol => $_[6],
               -port      => 161
            );
         } else {
            ($session, $error) = Net::SNMP->session(
               -hostname     => $_[0],
               -version      => 'snmpv3',
               -username     => $_[3],
               -authkey      => $_[4],
               -authpassword => $_[5],
               -authprotocol => $_[6],
               -privkey      => $_[7],
               -privpassword => $_[8],
               -privprotocol => $_[9],
               -port      => 161
            );
         }
      } elsif ($_[10] eq "0") {
         if($_[9] =~ /hash/i){
            ($session, $error) = Net::SNMP->session(
               -hostname     => $_[0],
               -version      => 'snmpv3',
               -username     => $_[3],
               -authpassword => $_[5],
               -authprotocol => $_[6],
               -nonblocking => 0,
               -translate   => [-octetstring => 0],
               -port      => 161
            );
         } else {
            ($session, $error) = Net::SNMP->session(
               -hostname     => $_[0],
               -version      => 'snmpv3',
               -username     => $_[3],
               -authkey      => $_[4],
               -authpassword => $_[5],
               -authprotocol => $_[6],
               -privkey      => $_[7],
               -privpassword => $_[8],
               -privprotocol => $_[9],
               -nonblocking => 0,
               -translate   => [-octetstring => 0],
               -port      => 161
            );
         }
      }
   }
   return ($session, $error);
}



1;